<!DOCTYPE html>
<html>

<head>

  <meta charset="utf-8">
  <title>Diagramas a partir de texto</title>

  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" rel="stylesheet"
    integrity="sha384-Zenh87qX5JnK2Jl0vWa8Ck2rdkQ2Bzep5IDxbcnCeuOxjzrPF/et3URy9Bv1WTRi" crossorigin="anonymous">
  <link type=‘text/css’ rel=‘stylesheet’ href=‘https://www.uco.es/~in1rosaj/tools/jsUML2/ejemplos/css/UDStyle.css’ media=‘screen’ />
  
  <script type="text/javascript" src="https://www.uco.es/~in1rosaj/tools/jsUML2/ejemplos/UDCore.js"></script>
  <script type="text/javascript" src="https://www.uco.es/~in1rosaj/tools/jsUML2/ejemplos/UDModules.js"></script>

  <script type="text/javascript">
    window.onload = function () {

      var classDiagram = new UMLClassDiagram(
        { id: 'classDiagram', width: 4000, height: 2000 }
      );
      classDiagram.setName('Modelo PIM')
      // CLASES
      var cliente = new UMLClass({ x: 10, y: 100 });
      var tipo_cliente = new UMLClass({ x: 0, y: 250 });
      var reservacion = new UMLClass({ x: 300, y: 90 });
      var habitacion = new UMLClass({ x: 600, y: 106 });
      var imagen = new UMLClass({ x: 660, y: 250 });
      var tipo_habitacion = new UMLClass({ x: 900, y: 103 });
      
      cliente.setName("Cliente");
      cliente.addAttribute('+rut:String');
      cliente.addAttribute('+apellidos:String');
      cliente.addAttribute('+nombres:String');
      cliente.addAttribute('+fecha_nacimiento:date');

      tipo_cliente.setName("<<enumeration>>\nTipo_Cliente");
      tipo_cliente.addAttribute('+nombre:String');
      tipo_cliente.addAttribute('+descripcion: String');
      tipo_cliente.addAttribute('+porcentaje_descuento:int');

      reservacion.setName("Reservacion");
      reservacion.addAttribute('+fecha_inicial:date');
      reservacion.addAttribute('+fecha_final:date');
      reservacion.addAttribute('+porcentaje_descuento:int');
      reservacion.addAttribute('+noches:int');
      reservacion.addAttribute('+dias:int');
      reservacion.addAttribute('+total:double');

      habitacion.setName("Habitacion");
      habitacion.addAttribute('+estado:boolean');
      habitacion.addAttribute('+numero_habitacion:int');
      habitacion.addAttribute('+precio:double');

      tipo_habitacion.setName("<<enumeration>>\nTipo_Habitacion");
      tipo_habitacion.addAttribute('+nombre:String');
      tipo_habitacion.addAttribute('+descripcion: String');
      
      imagen.setName("Imagen");

      classDiagram.addElement(cliente);
      classDiagram.addElement(tipo_cliente);
      classDiagram.addElement(reservacion);
      classDiagram.addElement(habitacion);
      classDiagram.addElement(imagen);
      classDiagram.addElement(tipo_habitacion);
    

      var dependencia1 = new UMLAssociation({ a: cliente, b: tipo_cliente });
      dependencia1.setMultiplicityA('*');
      dependencia1.setMultiplicityB('1');
      classDiagram.addElement(dependencia1);

      var dependencia2 = new UMLAssociation({ a: cliente, b: reservacion }); 
      dependencia2.setMultiplicityA('1');
      dependencia2.setMultiplicityB('*');
      classDiagram.addElement(dependencia2);

      var dependencia3 = new UMLAssociation({ a: reservacion, b: habitacion });
      dependencia3.setMultiplicityA('*');
      dependencia3.setMultiplicityB('1..*');
      classDiagram.addElement(dependencia3);

      var dependencia4 = new UMLAssociation({ a: habitacion, b: imagen });
      dependencia4.setMultiplicityA('1');
      dependencia4.setMultiplicityB('0..*');
      classDiagram.addElement(dependencia4);

      var dependencia5 = new UMLAssociation({ a: habitacion, b: tipo_habitacion });
      dependencia5.setMultiplicityA('*');
      dependencia5.setMultiplicityB('1');
      classDiagram.addElement(dependencia5);


      classDiagram.draw();
      classDiagram.interaction(true);

    }
  </script>
</head>

<body>

  <div class="row">
    <div class="col-md-10 m-auto my-5">
      <div class="card">
        <div class="card-header">
          <strong>Diagrama de clases con jsUML2 (PIM)</strong>
        </div>
        <div class="card-body">
          <p>
            Ejemplo librería <a target="_blank"
              href="https://www.uco.es/users/in1rosaj//tools/jsUML2/doc/TheProgrammersGuide_003.htm">jsUML2</a>
            para crear diagramas a partir de texto y su
            <a target="_blank" href="https://www.uco.es/~in1rosaj/tools/jsUML2/editor/index.html">Live editor</a>
          </p>
          <div id="classDiagram"></div>
        </div>
      </div>
    </div>
  </div>

</body>

</html>